"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from esv_sdk.types import BaseModel
from esv_sdk.utils import FieldMetadata, QueryParamMetadata
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GetPassageHTMLRequestTypedDict(TypedDict):
    query: str
    r"""Bible passage reference (e.g., \"John 3:16\" or \"43011016\")"""
    include_passage_references: NotRequired[bool]
    r"""Include passage references before passages"""
    include_verse_numbers: NotRequired[bool]
    r"""Include verse numbers"""
    include_first_verse_numbers: NotRequired[bool]
    r"""Include the verse number for the first verse of a chapter"""
    include_footnotes: NotRequired[bool]
    r"""Include callouts to footnotes in the text."""
    include_footnote_body: NotRequired[bool]
    r"""Include footnote body content"""
    include_headings: NotRequired[bool]
    r"""Include passage headings"""
    include_short_copyright: NotRequired[bool]
    r"""Include a short copyright notice"""
    include_copyright: NotRequired[bool]
    r"""Include the full copyright notice"""
    include_passage_horizontal_lines: NotRequired[bool]
    r"""Include horizontal lines between passages"""
    include_heading_horizontal_lines: NotRequired[bool]
    r"""Include horizontal lines under headings"""
    horizontal_line_length: NotRequired[int]
    r"""Length of horizontal lines"""
    include_selahs: NotRequired[bool]
    r"""Include \"Selah\" in passage text"""
    include_css_link: NotRequired[bool]
    r"""Include a link to the ESV API CSS file"""
    inline_styles: NotRequired[bool]
    r"""Include inline styles on HTML elements"""
    wrapping_div: NotRequired[bool]
    r"""Wrap the HTML output in a div with class=\"esv\" """
    div_classes: NotRequired[str]
    r"""Classes to add to the wrapping div"""


class GetPassageHTMLRequest(BaseModel):
    query: Annotated[
        str,
        pydantic.Field(alias="q"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ]
    r"""Bible passage reference (e.g., \"John 3:16\" or \"43011016\")"""

    include_passage_references: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-passage-references"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = True
    r"""Include passage references before passages"""

    include_verse_numbers: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-verse-numbers"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = True
    r"""Include verse numbers"""

    include_first_verse_numbers: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-first-verse-numbers"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = True
    r"""Include the verse number for the first verse of a chapter"""

    include_footnotes: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-footnotes"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = True
    r"""Include callouts to footnotes in the text."""

    include_footnote_body: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-footnote-body"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = True
    r"""Include footnote body content"""

    include_headings: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-headings"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = True
    r"""Include passage headings"""

    include_short_copyright: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-short-copyright"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = False
    r"""Include a short copyright notice"""

    include_copyright: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-copyright"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = False
    r"""Include the full copyright notice"""

    include_passage_horizontal_lines: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-passage-horizontal-lines"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = False
    r"""Include horizontal lines between passages"""

    include_heading_horizontal_lines: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-heading-horizontal-lines"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = False
    r"""Include horizontal lines under headings"""

    horizontal_line_length: Annotated[
        Optional[int],
        pydantic.Field(alias="horizontal-line-length"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = 55
    r"""Length of horizontal lines"""

    include_selahs: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-selahs"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = True
    r"""Include \"Selah\" in passage text"""

    include_css_link: Annotated[
        Optional[bool],
        pydantic.Field(alias="include-css-link"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = True
    r"""Include a link to the ESV API CSS file"""

    inline_styles: Annotated[
        Optional[bool],
        pydantic.Field(alias="inline-styles"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = False
    r"""Include inline styles on HTML elements"""

    wrapping_div: Annotated[
        Optional[bool],
        pydantic.Field(alias="wrapping-div"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = True
    r"""Wrap the HTML output in a div with class=\"esv\" """

    div_classes: Annotated[
        Optional[str],
        pydantic.Field(alias="div-classes"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = "esv"
    r"""Classes to add to the wrapping div"""
